<?php
/**
 * @package		HikaShop for Joomla!
 * @version		1.5.3
 * @author		hikashop.com
 * @copyright	(C) 2010-2011 HIKARI SOFTWARE. All rights reserved.
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
class plgHikashoppaymentOgone extends JPlugin
{
	var $accepted_currencies = array(
		'EUR'
	);
    var $debugData = array();
    function onPaymentDisplay(&$order,&$methods,&$usable_methods){
    	if(!empty($methods)){
    		foreach($methods as $method){
				if($method->payment_type!='ogone' || !$method->enabled){
					continue;
				}
				if(!empty($method->payment_zone_namekey)){
					$zoneClass=hikashop_get('class.zone');
	    			$zones = $zoneClass->getOrderZones($order);
					if(!in_array($method->payment_zone_namekey,$zones)){
						return true;
					}
				}
				$currencyClass = hikashop_get('class.currency');
				$null=null;
				if(!empty($order->total)){
					$currency_id = intval(@$order->total->prices[0]->price_currency_id);
					$currency = $currencyClass->getCurrencies($currency_id,$null);
					if(!empty($currency) && !in_array(@$currency[$currency_id]->currency_code,$this->accepted_currencies)){
						return true;
					}
				}
				$usable_methods[$method->ordering]=$method;
    		}
    	}
    	return true;
    }
    function onPaymentSave(&$cart,&$rates,&$payment_id){
    	$usable = array();
    	$this->onPaymentDisplay($cart,$rates,$usable);
    	$payment_id = (int) $payment_id;
    	foreach($usable as $usable_method){
    		if($usable_method->payment_id==$payment_id){
    			return $usable_method;
    		}
    	}
    	return false;
    }
    function onAfterOrderConfirm(&$order,&$methods,$method_id){
    	$method =& $methods[$method_id];
		$tax_total = '';
		$discount_total = '';
		$currencyClass = hikashop_get('class.currency');
		$currencies=null;
		$currencies = $currencyClass->getCurrencies($order->order_currency_id,$currencies);
		$currency=$currencies[$order->order_currency_id];
		hikashop_loadUser(true,true); //reset user data in case the emails were changed in the email code
		$user = hikashop_loadUser(true);
		$lang = &JFactory::getLanguage();
		$locale=strtolower(substr($lang->get('tag'),0,2));
		global $Itemid;
		$url_itemid='';
		if(!empty($Itemid)){
			$url_itemid='&Itemid='.$Itemid;
		}
		$notify_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=paypal&tmpl=component&lang='.$locale.$url_itemid;
		$return_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id='.$order->order_id.$url_itemid;
		$cancel_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=order&task=cancel_order&order_id='.$order->order_id.$url_itemid;
		$debug = $method->payment_params->debug;
		if(!isset($method->payment_params->no_shipping)) $method->payment_params->no_shipping = 1;
		if(!empty($method->payment_params->rm)) $method->payment_params->rm = 2;
		$vars = array(
		"PSPID" => $method->payment_params->pspid ,
		"orderID" => @$order->order_id,
		"amount" => round(100 * @$order->cart->full_total->prices[0]->price_value_with_tax),
		"currency" => $currency->currency_code,
		"language" => "de_DE",
		"CN" => @$order->cart->billing_address->address_firstname." ".@$order->cart->billing_address->address_lastname,
		"EMAIL" => $user->user_email,
    "LOGO" => 'XXXXXXX',
    "BGCOLOR" => 'black',
    "TXTCOLOR" => '#095197',
    "TBLBGCOLOR" => 'lavender'
		);
        $vars["owneraddress"]=@$order->cart->billing_address->address_street;
        $vars["ownerZIP"]=@$order->cart->billing_address->address_post_code;
        $vars["ownertown"]=@$order->cart->billing_address->address_city;
        $vars["ownercty"]=@$order->cart->billing_address->address_country;
    	$vars["ownertelno"]=@$order->cart->billing_address->address_telephone;

		$pass=$method->payment_params->passphraseIN;
    	$shasign="AMOUNT=".$vars["amount"].$pass."BGCOLOR=".$vars["BGCOLOR"].$pass."CN=".$vars["CN"].$pass."CURRENCY=".$vars["currency"].$pass."EMAIL=".$vars["EMAIL"].$pass;
    	$shasign=$shasign."LANGUAGE=de_DE".$pass."LOGO=".$vars["LOGO"].$pass."ORDERID=".$vars["orderID"].$pass."OWNERADDRESS=".$vars["owneraddress"].$pass;
    	$shasign=$shasign."OWNERCTY=".$vars["ownercty"].$pass."OWNERTELNO=".$vars["ownertelno"].$pass."OWNERTOWN=".$vars["ownertown"].$pass;
    	$shasign=$shasign."OWNERZIP=".$vars["ownerZIP"].$pass."PSPID=".$vars["PSPID"].$pass."TBLBGCOLOR=".$vars["TBLBGCOLOR"].$pass."TXTCOLOR=".$vars["TXTCOLOR"].$pass;
    	
    	$vars["SHAsign"] = strtoupper(hash("sha512", $shasign, false));
    	
    	JHTML::_('behavior.mootools');
		$app =& JFactory::getApplication();
		$name = $method->payment_type.'_end.php';
    	$path = JPATH_THEMES.DS.$app->getTemplate().DS.'hikashoppayment'.DS.$name;
    	if(!file_exists($path)){
    		if(version_compare(JVERSION,'1.6','<')){
    			$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$name;
    		}else{
    			$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$method->payment_type.DS.$name;
    		}
    		if(!file_exists($path)){
    			return true;
    		}
    	}
    	require($path);
    	return true;
    }
    function onPaymentNotification(&$statuses){
    	$pluginsClass = hikashop_get('class.plugins');
		$elements = $pluginsClass->getMethods('payment','ogone');
		if(empty($elements)) return false;
		$element = reset($elements);
		if(!$element->payment_params->notification){
			return false;
		}
    	$vars = array();
    	$sig = "";
    	$filter = & JFilterInput::getInstance();
    	foreach($_REQUEST as $key => $value){
    		$key = $filter->clean($key);
    		if ($key == "SHASIGN")
    			continue;
    		/**if(preg_match("#^[0-9a-z_-]{1,30}$#i",$key)&&!preg_match("#^cmd$#i",$key)){*/
    			$value = JRequest::getString($key);
	    		$vars[$key]=$value;
	    		$sig = $sig.$key."=".$value.$element->payment_params->passphraseOUT;
    		
    	}
    	
    	$sig = strtoupper(hash("sha512", $sig, false));
    	/**if ($sig != $vars["SHASIGN"])
    	{
    		echo "Signatur nicht akzeptiert.";
    		return false;
    	}*/
    	
		$orderClass = hikashop_get('class.order');
		$dbOrder = $orderClass->get((int)@$vars['orderID']);
		if(empty($dbOrder)){
			echo "Could not load any order for your notification ".@$vars['orderID'];
			return false;
		}
		$order = null;
		$order->order_id = $dbOrder->order_id;
		$order->old_status->order_status=$dbOrder->order_status;
		$order->history->history_reason=JText::sprintf('AUTOMATIC_PAYMENT_NOTIFICATION');
		$order->history->history_notified=0;
		$order->history->history_amount=@$vars['amount'].@$vars['currency'];
		$order->history->history_payment_id = $element->payment_id;
		$order->history->history_payment_method =$element->payment_type;
		$order->history->history_data = ob_get_clean();
		$order->history->history_type = 'payment';
	 	$currencyClass = hikashop_get('class.currency');
		$currencies=null;
		$currencies = $currencyClass->getCurrencies($dbOrder->order_currency_id,$currencies);
		$currency=$currencies[$dbOrder->order_currency_id];
	 	$price_check = round($dbOrder->order_full_price, (int)$currency->currency_locale['int_frac_digits'] );
	 	if($price_check != @$vars['amount'] || $currency->currency_code != @$vars['currency']){
	 		$order->order_status = $element->payment_params->invalid_status;
	 		$orderClass->save($order);
	 		return false;
	 	}
	 	if(@$vars["status"] == "5"){
	 		$order->order_status = $element->payment_params->verified_status;
	 		$order->history->history_notified=1;
	 	}else{
	 		$order->order_status = $element->payment_params->pending_status;
	 	}
	 	$orderClass->save($order);
    	return true;
    }
    function onPaymentConfiguration(&$element){
    	$subtask = JRequest::getCmd('subtask','');
    	if($subtask=='ips'){
    		$ips = null;
			echo implode(',',$this->_getIPList($ips));
			exit;
    	}else{
    		$this->ogone = JRequest::getCmd('name','ogone');
			if(empty($element)){
				$element = null;
    			$element->payment_name='ogone.com';
    			$element->payment_description='You can pay by credit card using this payment method';
    			$element->payment_images='MasterCard,VISA,American_Express';
    			$element->payment_type='ogone';
    			$element->payment_params=null;
    			$element->payment_params->url='https://secure.ogone.com/ncol/test/orderstandard.asp';
    			$element->payment_params->notification=1;
    			$element->payment_params->details=0;
    			$element->payment_params->invalid_status='cancelled';
    			$element->payment_params->pending_status='created';
    			$element->payment_params->verified_status='confirmed';
    			$element->payment_params->address_override=1;
    			$element = array($element);
    		}
    		$obj = reset($element);
	    	$bar = & JToolBar::getInstance('toolbar');
			JToolBarHelper::save();
			JToolBarHelper::apply();
			JToolBarHelper::cancel();
			JToolBarHelper::divider();
			$bar->appendButton( 'Pophelp','payment-ogone-form');
			hikashop_setTitle('Ogone','plugin','plugins&plugin_type=payment&task=edit&name='.$this->ogone);
			$app =& JFactory::getApplication();
			$app->setUserState( HIKASHOP_COMPONENT.'.payment_plugin_type', $this->ogone);
			$this->address = hikashop_get('type.address');
			$this->category = hikashop_get('type.categorysub');
			$this->category->type = 'status';
    	}
    }
    function onPaymentConfigurationSave(&$element){
    	if(!empty($element->payment_params->ips)){
    		$element->payment_params->ips=explode(',',$element->payment_params->ips);
    	}
		return true;
    }
}